<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card class="q-dialog-plugin">
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Vídeo'"
        />
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-sm">
          <q-input
            v-model="form.title"
            class="col-12"
            label="Título"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.title.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.title)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-select
            v-model="form.categoryId"
            :options="options"
            class="col-12"
            label="Categoria"
            color="primary"
            option-value="id"
            options-cover
            options-dense
            bottom-slots
            map-options
            emit-value
            outlined
            dense
            :error="$v.form.categoryId.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.categoryId)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-select>

          <q-input
            v-model="form.url"
            class="col-12"
            label="Link"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.url.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.url)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-uploader
            class="col-12"
            text-color="dark"
            accept="image/*"
            label="Imagem"
            color="white"
            hide-upload-btn
            no-thumbnails
            bordered
            flat
            @added="upload"
          />

          <q-input
            v-model="form.thumbnail"
            class="col-12"
            label="Imagem"
            color="primary"
            bottom-slots
            outlined
            disable
            dense
            :error="$v.form.thumbnail.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.thumbnail)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>
        </q-form>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required, url } from 'vuelidate/lib/validators'
import { uid } from 'quasar'
import path from 'path'

export default {
  name: 'FormVideo',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      required: true
    },
    options: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      form: this.value
    }
  },
  validations: {
    form: {
      title: {
        required
      },
      url: {
        required,
        url
      },
      thumbnail: {
        required
      },
      categoryId: {
        required
      }
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    async save () {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: this.form.id ? 'PATCH' : 'POST',
          url: `/VideoLessons/${this.form.id || ''}`,
          data: JSON.parse(JSON.stringify(this.form))
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Salvo com sucesso')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
        this.$emit('ok')
        this.hide()
      }
    },
    async upload (files) {
      const newExt = path.extname(files[0].name)
      const oldExt = path.extname(this.form.thumbnail) || newExt
      const fileName = this.form.thumbnail.split('.')[0] || uid()

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Storages/videos/upload',
          headers: { 'Content-Type': 'multipart/form-data' },
          data: new FormData()
        }

        axiosConfig.data.append('file', files[0], fileName + newExt)

        await this.$axios(axiosConfig)

        this.form.thumbnail = fileName + newExt

        if (oldExt !== newExt) {
          await this.delete(fileName + oldExt)
        }
      } catch (err) {
        this.axiosCatch(err)
      }
    },
    async delete (file) {
      try {
        const axiosConfig = {
          method: 'DELETE',
          url: `/Storages/videos/files/${file}`
        }

        await this.$axios(axiosConfig)
      } catch (err) {
        this.axiosCatch(err)
      }
    }
  }
}
</script>
